Index: /palm/trunk/SOURCE/init_1d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_1d_model.f90	(revision 1352)
+++ /palm/trunk/SOURCE/init_1d_model.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants provided with KIND-attribute 
 ! 
 ! Former revisions:
@@ -113,23 +113,23 @@
        kh1d = km_constant / prandtl_number
     ELSE
-       e1d = 0.0; e1d_p = 0.0
-       kh1d = 0.0; km1d = 0.0
-       rif1d = 0.0
+       e1d = 0.0_wp; e1d_p = 0.0_wp
+       kh1d = 0.0_wp; km1d = 0.0_wp
+       rif1d = 0.0_wp
 !
 !--    Compute the mixing length
-       l_black(nzb) = 0.0
+       l_black(nzb) = 0.0_wp
 
        IF ( TRIM( mixing_length_1d ) == 'blackadar' )  THEN
 !
 !--       Blackadar mixing length
-          IF ( f /= 0.0 )  THEN
-             lambda = 2.7E-4 * SQRT( ug(nzt+1)**2 + vg(nzt+1)**2 ) /           &
-                               ABS( f ) + 1E-10
+          IF ( f /= 0.0_wp )  THEN
+             lambda = 2.7E-4_wp * SQRT( ug(nzt+1)**2 + vg(nzt+1)**2 ) /        &
+                               ABS( f ) + 1E-10_wp
           ELSE
-             lambda = 30.0
+             lambda = 30.0_wp
           ENDIF
 
           DO  k = nzb+1, nzt+1
-             l_black(k) = kappa * zu(k) / ( 1.0 + kappa * zu(k) / lambda )
+             l_black(k) = kappa * zu(k) / ( 1.0_wp + kappa * zu(k) / lambda )
           ENDDO
 
@@ -152,31 +152,31 @@
 !-- value in order to avoid too small time steps caused by the diffusion limit
 !-- in the initial phase of a run (at k=1, dz/2 occurs in the limiting formula!)
-    u1d(0:1)   = 0.1
-    u1d_p(0:1) = 0.1
-    v1d(0:1)   = 0.1
-    v1d_p(0:1) = 0.1
+    u1d(0:1)   = 0.1_wp
+    u1d_p(0:1) = 0.1_wp
+    v1d(0:1)   = 0.1_wp
+    v1d_p(0:1) = 0.1_wp
 
 !
 !-- For u*, theta* and the momentum fluxes plausible values are set
     IF ( prandtl_layer )  THEN
-       us1d = 0.1   ! without initial friction the flow would not change
+       us1d = 0.1_wp   ! without initial friction the flow would not change
     ELSE
-       e1d(nzb+1)  = 1.0
-       km1d(nzb+1) = 1.0
-       us1d = 0.0
+       e1d(nzb+1)  = 1.0_wp
+       km1d(nzb+1) = 1.0_wp
+       us1d = 0.0_wp
     ENDIF
-    ts1d = 0.0
-    usws1d = 0.0
-    vsws1d = 0.0
+    ts1d = 0.0_wp
+    usws1d = 0.0_wp
+    vsws1d = 0.0_wp
     z01d  = roughness_length
     z0h1d = z0h_factor * z01d 
-    IF ( humidity .OR. passive_scalar )  qs1d = 0.0
+    IF ( humidity .OR. passive_scalar )  qs1d = 0.0_wp
 
 !
 !-- Tendencies must be preset in order to avoid runtime errors within the
 !-- first Runge-Kutta step
-    te_em = 0.0
-    te_um = 0.0
-    te_vm = 0.0
+    te_em = 0.0_wp
+    te_um = 0.0_wp
+    te_vm = 0.0_wp
 
 !
@@ -270,6 +270,6 @@
           DO  k = nzb_diff, nzt
 
-             kmzm = 0.5 * ( km1d(k-1) + km1d(k) )
-             kmzp = 0.5 * ( km1d(k) + km1d(k+1) )
+             kmzm = 0.5_wp * ( km1d(k-1) + km1d(k) )
+             kmzp = 0.5_wp * ( km1d(k) + km1d(k+1) )
 !
 !--          u-component
@@ -289,14 +289,14 @@
 !
 !--             TKE
-                kmzm = 0.5 * ( km1d(k-1) + km1d(k) )
-                kmzp = 0.5 * ( km1d(k) + km1d(k+1) )
+                kmzm = 0.5_wp * ( km1d(k-1) + km1d(k) )
+                kmzp = 0.5_wp * ( km1d(k) + km1d(k+1) )
                 IF ( .NOT. humidity )  THEN
                    pt_0 = pt_init(k)
                    flux =  ( pt_init(k+1)-pt_init(k-1) ) * dd2zu(k)
                 ELSE
-                   pt_0 = pt_init(k) * ( 1.0 + 0.61 * q_init(k) )
-                   flux = ( ( pt_init(k+1) - pt_init(k-1) ) +                 &
-                            0.61 * pt_init(k) * ( q_init(k+1) - q_init(k-1) ) &
-                          ) * dd2zu(k)
+                   pt_0 = pt_init(k) * ( 1.0_wp + 0.61_wp * q_init(k) )
+                   flux = ( ( pt_init(k+1) - pt_init(k-1) ) +                  &
+                            0.61_wp * pt_init(k) *                             &
+                            ( q_init(k+1) - q_init(k-1) ) ) * dd2zu(k)
                 ENDIF
 
@@ -304,7 +304,7 @@
 !
 !--                According to Detering, c_e=0.064
-                   dissipation = 0.064 * e1d(k) * SQRT( e1d(k) ) / l1d(k)
+                   dissipation = 0.064_wp * e1d(k) * SQRT( e1d(k) ) / l1d(k)
                 ELSEIF ( dissipation_1d == 'as_in_3d_model' )  THEN
-                   dissipation = ( 0.19 + 0.74 * l1d(k) / l_grid(k) ) &
+                   dissipation = ( 0.19_wp + 0.74_wp * l1d(k) / l_grid(k) )    &
                                  * e1d(k) * SQRT( e1d(k) ) / l1d(k)
                 ENDIF
@@ -329,13 +329,13 @@
 
              k = nzb+1
-             kmzm = 0.5 * ( km1d(k-1) + km1d(k) )
-             kmzp = 0.5 * ( km1d(k) + km1d(k+1) )
+             kmzm = 0.5_wp * ( km1d(k-1) + km1d(k) )
+             kmzp = 0.5_wp * ( km1d(k) + km1d(k+1) )
              IF ( .NOT. humidity )  THEN
                 pt_0 = pt_init(k)
                 flux =  ( pt_init(k+1)-pt_init(k-1) ) * dd2zu(k)
              ELSE
-                pt_0 = pt_init(k) * ( 1.0 + 0.61 * q_init(k) )
-                flux = ( ( pt_init(k+1) - pt_init(k-1) ) +                 &
-                         0.61 * pt_init(k) * ( q_init(k+1) - q_init(k-1) ) &
+                pt_0 = pt_init(k) * ( 1.0_wp + 0.61_wp * q_init(k) )
+                flux = ( ( pt_init(k+1) - pt_init(k-1) ) +                     &
+                         0.61_wp * pt_init(k) * ( q_init(k+1) - q_init(k-1) )  &
                        ) * dd2zu(k)
              ENDIF
@@ -344,7 +344,7 @@
 !
 !--             According to Detering, c_e=0.064
-                dissipation = 0.064 * e1d(k) * SQRT( e1d(k) ) / l1d(k)
+                dissipation = 0.064_wp * e1d(k) * SQRT( e1d(k) ) / l1d(k)
              ELSEIF ( dissipation_1d == 'as_in_3d_model' )  THEN
-                dissipation = ( 0.19 + 0.74 * l1d(k) / l_grid(k) ) &
+                dissipation = ( 0.19_wp + 0.74_wp * l1d(k) / l_grid(k) )       &
                               * e1d(k) * SQRT( e1d(k) ) / l1d(k)
              ENDIF
@@ -354,10 +354,10 @@
              te_u(k) = f * ( v1d(k) - vg(k) ) + (                              &
                        kmzp * ( u1d(k+1) - u1d(k) ) * ddzu(k+1) + usws1d       &
-                                                ) * 2.0 * ddzw(k)
+                                                ) * 2.0_wp * ddzw(k)
 !
 !--          v-component
              te_v(k) = -f * ( u1d(k) - ug(k) ) + (                             &
                        kmzp * ( v1d(k+1) - v1d(k) ) * ddzu(k+1) + vsws1d       &
-                                                 ) * 2.0 * ddzw(k)
+                                                 ) * 2.0_wp * ddzw(k)
 !
 !--          TKE
@@ -394,5 +394,5 @@
 !--          integration due to numerical inaccuracies. In such cases the TKE
 !--          value is reduced to 10 percent of its old value.
-             WHERE ( e1d_p < 0.0 )  e1d_p = 0.1 * e1d
+             WHERE ( e1d_p < 0.0_wp )  e1d_p = 0.1_wp * e1d
           ENDIF
 
@@ -417,11 +417,11 @@
 
                 DO  k = nzb+1, nzt
-                   te_um(k) = -9.5625 * te_u(k) + 5.3125 * te_um(k)
-                   te_vm(k) = -9.5625 * te_v(k) + 5.3125 * te_vm(k)
+                   te_um(k) = -9.5625_wp * te_u(k) + 5.3125_wp * te_um(k)
+                   te_vm(k) = -9.5625_wp * te_v(k) + 5.3125_wp * te_vm(k)
                 ENDDO
 
                 IF ( .NOT. constant_diffusion )  THEN
                    DO k = nzb+1, nzt
-                      te_em(k) = -9.5625 * te_e(k) + 5.3125 * te_em(k)
+                      te_em(k) = -9.5625_wp * te_e(k) + 5.3125_wp * te_em(k)
                    ENDDO
                 ENDIF
@@ -440,6 +440,6 @@
          ! v1d_p(nzb) = -v1d_p(nzb+1)
 
-          u1d_p(nzb) = 0.0
-          v1d_p(nzb) = 0.0
+          u1d_p(nzb) = 0.0_wp
+          v1d_p(nzb) = 0.0_wp
 
 !
@@ -460,28 +460,31 @@
 !
 !--             Compute theta* using Rif numbers of the previous time step
-                IF ( rif1d(1) >= 0.0 )  THEN
+                IF ( rif1d(1) >= 0.0_wp )  THEN
 !
 !--                Stable stratification
-                   ts1d = kappa * ( pt_init(nzb+1) - pt_init(nzb) ) /       &
-                          ( LOG( zu(nzb+1) / z0h1d ) + 5.0 * rif1d(nzb+1) * &
-                                          ( zu(nzb+1) - z0h1d ) / zu(nzb+1) &
+                   ts1d = kappa * ( pt_init(nzb+1) - pt_init(nzb) ) /          &
+                          ( LOG( zu(nzb+1) / z0h1d ) + 5.0_wp * rif1d(nzb+1) * &
+                                          ( zu(nzb+1) - z0h1d ) / zu(nzb+1)    &
                           )
                 ELSE
 !
 !--                Unstable stratification
-                   a = SQRT( 1.0 - 16.0 * rif1d(nzb+1) )
-                   b = SQRT( 1.0 - 16.0 * rif1d(nzb+1) / zu(nzb+1) * z0h1d )
+                   a = SQRT( 1.0_wp - 16.0_wp * rif1d(nzb+1) )
+                   b = SQRT( 1.0_wp - 16.0_wp * rif1d(nzb+1) /                 &
+                       zu(nzb+1) * z0h1d )
 !
 !--                In the borderline case the formula for stable stratification 
 !--                must be applied, because otherwise a zero division would
 !--                occur in the argument of the logarithm.
-                   IF ( a == 0.0  .OR.  b == 0.0 )  THEN
+                   IF ( a == 0.0_wp  .OR.  b == 0.0_wp )  THEN
                       ts1d = kappa * ( pt_init(nzb+1) - pt_init(nzb) ) /       &
-                             ( LOG( zu(nzb+1) / z0h1d ) + 5.0 * rif1d(nzb+1) * &
-                                             ( zu(nzb+1) - z0h1d ) / zu(nzb+1) &
+                             ( LOG( zu(nzb+1) / z0h1d ) +                      &
+                               5.0_wp * rif1d(nzb+1) *                         &
+                               ( zu(nzb+1) - z0h1d ) / zu(nzb+1)               &
                              )
                    ELSE
-                      ts1d = kappa * ( pt_init(nzb+1) - pt_init(nzb) ) / &
-                             LOG( (a-1.0) / (a+1.0) * (b+1.0) / (b-1.0) )
+                      ts1d = kappa * ( pt_init(nzb+1) - pt_init(nzb) ) /       &
+                             LOG( (a-1.0_wp) / (a+1.0_wp) *                    &
+                                  (b+1.0_wp) / (b-1.0_wp) )
                    ENDIF
                 ENDIF
@@ -500,9 +503,9 @@
                    flux = ts1d
                 ELSE
-                   pt_0 = pt_init(nzb+1) * ( 1.0 + 0.61 * q_init(nzb+1) )
-                   flux = ts1d + 0.61 * pt_init(k) * qs1d
+                   pt_0 = pt_init(nzb+1) * ( 1.0_wp + 0.61_wp * q_init(nzb+1) )
+                   flux = ts1d + 0.61_wp * pt_init(k) * qs1d
                 ENDIF
                 rif1d(nzb+1) = zu(nzb+1) * kappa * g * flux / &
-                               ( pt_0 * ( us1d**2 + 1E-30 ) )
+                               ( pt_0 * ( us1d**2 + 1E-30_wp ) )
              ENDIF
 
@@ -512,21 +515,22 @@
                    flux = ( pt_init(k+1) - pt_init(k-1) ) * dd2zu(k)
                 ELSE
-                   pt_0 = pt_init(k) * ( 1.0 + 0.61 * q_init(k) )
+                   pt_0 = pt_init(k) * ( 1.0_wp + 0.61_wp * q_init(k) )
                    flux = ( ( pt_init(k+1) - pt_init(k-1) )                    &
-                            + 0.61 * pt_init(k) * ( q_init(k+1) - q_init(k-1) )&
+                            + 0.61_wp * pt_init(k)                             &
+                            * ( q_init(k+1) - q_init(k-1) )                    &
                           ) * dd2zu(k)
                 ENDIF
-                IF ( rif1d(k) >= 0.0 )  THEN
-                   rif1d(k) = g / pt_0 * flux /                              &
-                              (  ( ( u1d(k+1) - u1d(k-1) ) * dd2zu(k) )**2   &
-                               + ( ( v1d(k+1) - v1d(k-1) ) * dd2zu(k) )**2   &
-                               + 1E-30                                       &
+                IF ( rif1d(k) >= 0.0_wp )  THEN
+                   rif1d(k) = g / pt_0 * flux /                                &
+                              (  ( ( u1d(k+1) - u1d(k-1) ) * dd2zu(k) )**2     &
+                               + ( ( v1d(k+1) - v1d(k-1) ) * dd2zu(k) )**2     &
+                               + 1E-30_wp                                      &
                               )
                 ELSE
-                   rif1d(k) = g / pt_0 * flux /                              &
-                              (  ( ( u1d(k+1) - u1d(k-1) ) * dd2zu(k) )**2   &
-                               + ( ( v1d(k+1) - v1d(k-1) ) * dd2zu(k) )**2   &
-                               + 1E-30                                       &
-                              ) * ( 1.0 - 16.0 * rif1d(k) )**0.25
+                   rif1d(k) = g / pt_0 * flux /                                &
+                              (  ( ( u1d(k+1) - u1d(k-1) ) * dd2zu(k) )**2     &
+                               + ( ( v1d(k+1) - v1d(k-1) ) * dd2zu(k) )**2     &
+                               + 1E-30_wp                                      &
+                              ) * ( 1.0_wp - 16.0_wp * rif1d(k) )**0.25_wp
                 ENDIF
              ENDDO
@@ -543,9 +547,9 @@
                 uv_total = SQRT( u1d(nzb+1)**2 + v1d(nzb+1)**2 )
 
-                IF ( rif1d(nzb+1) >= 0.0 )  THEN
+                IF ( rif1d(nzb+1) >= 0.0_wp )  THEN
 !
 !--                Stable stratification
                    us1d = kappa * uv_total / (                                 &
-                             LOG( zu(nzb+1) / z01d ) + 5.0 * rif1d(nzb+1) *    &
+                             LOG( zu(nzb+1) / z01d ) + 5.0_wp * rif1d(nzb+1) * &
                                               ( zu(nzb+1) - z01d ) / zu(nzb+1) &
                                              )
@@ -553,20 +557,21 @@
 !
 !--                Unstable stratification
-                   a = 1.0 / SQRT( SQRT( 1.0 - 16.0 * rif1d(nzb+1) ) )
-                   b = 1.0 / SQRT( SQRT( 1.0 - 16.0 * rif1d(nzb+1) / zu(nzb+1) &
-                                                    * z01d ) )
+                   a = 1.0_wp / SQRT( SQRT( 1.0_wp - 16.0_wp * rif1d(nzb+1) ) )
+                   b = 1.0_wp / SQRT( SQRT( 1.0_wp - 16.0_wp * rif1d(nzb+1) /  &
+                                                     zu(nzb+1) * z01d ) )
 !
 !--                In the borderline case the formula for stable stratification 
 !--                must be applied, because otherwise a zero division would
 !--                occur in the argument of the logarithm.
-                   IF ( a == 1.0  .OR.  b == 1.0 )  THEN
-                      us1d = kappa * uv_total / (                            &
-                             LOG( zu(nzb+1) / z01d ) +                       &
-                             5.0 * rif1d(nzb+1) * ( zu(nzb+1) - z01d ) /     &
+                   IF ( a == 1.0_wp  .OR.  b == 1.0_wp )  THEN
+                      us1d = kappa * uv_total / (                              &
+                             LOG( zu(nzb+1) / z01d ) +                         &
+                             5.0_wp * rif1d(nzb+1) * ( zu(nzb+1) - z01d ) /    &
                                                   zu(nzb+1) )
                    ELSE
                       us1d = kappa * uv_total / (                              &
-                                 LOG( (1.0+b) / (1.0-b) * (1.0-a) / (1.0+a) ) +&
-                                 2.0 * ( ATAN( b ) - ATAN( a ) )               &
+                                 LOG( (1.0_wp+b) / (1.0_wp-b) * (1.0_wp-a) /   &
+                                      (1.0_wp+a) ) +                           &
+                                 2.0_wp * ( ATAN( b ) - ATAN( a ) )            &
                                                 )
                    ENDIF
@@ -584,7 +589,7 @@
 !--             compatibility with the 3D model.
                 IF ( ibc_e_b == 2 )  THEN
-                   e1d(nzb+1) = ( us1d / 0.1 )**2
-!                  e1d(nzb+1) = ( us1d / 0.4 )**2  !not used so far, see also
-                                                   !prandtl_fluxes
+                   e1d(nzb+1) = ( us1d / 0.1_wp )**2
+!                  e1d(nzb+1) = ( us1d / 0.4_wp )**2  !not used so far, see also
+                                                      !prandtl_fluxes
                 ENDIF
                 e1d(nzb) = e1d(nzb+1)
@@ -593,32 +598,35 @@
 !
 !--                Compute q* 
-                   IF ( rif1d(1) >= 0.0 )  THEN
+                   IF ( rif1d(1) >= 0.0_wp )  THEN
 !
 !--                Stable stratification
-                   qs1d = kappa * ( q_init(nzb+1) - q_init(nzb) ) /         &
-                          ( LOG( zu(nzb+1) / z0h1d ) + 5.0 * rif1d(nzb+1) * &
-                                          ( zu(nzb+1) - z0h1d ) / zu(nzb+1) &
+                   qs1d = kappa * ( q_init(nzb+1) - q_init(nzb) ) /            &
+                          ( LOG( zu(nzb+1) / z0h1d ) + 5.0_wp * rif1d(nzb+1) * &
+                                          ( zu(nzb+1) - z0h1d ) / zu(nzb+1)    &
                           )
                 ELSE
 !
 !--                Unstable stratification
-                   a = SQRT( 1.0 - 16.0 * rif1d(nzb+1) )
-                   b = SQRT( 1.0 - 16.0 * rif1d(nzb+1) / zu(nzb+1) * z0h1d )
+                   a = SQRT( 1.0_wp - 16.0_wp * rif1d(nzb+1) )
+                   b = SQRT( 1.0_wp - 16.0_wp * rif1d(nzb+1) /                 &
+                                      zu(nzb+1) * z0h1d )
 !
 !--                In the borderline case the formula for stable stratification 
 !--                must be applied, because otherwise a zero division would
 !--                occur in the argument of the logarithm.
-                   IF ( a == 1.0  .OR.  b == 1.0 )  THEN
+                   IF ( a == 1.0_wp  .OR.  b == 1.0_wp )  THEN
                       qs1d = kappa * ( q_init(nzb+1) - q_init(nzb) ) /         &
-                             ( LOG( zu(nzb+1) / z0h1d ) + 5.0 * rif1d(nzb+1) * &
-                                             ( zu(nzb+1) - z0h1d ) / zu(nzb+1) &
+                             ( LOG( zu(nzb+1) / z0h1d ) +                      &
+                               5.0_wp * rif1d(nzb+1) *                         &
+                               ( zu(nzb+1) - z0h1d ) / zu(nzb+1)               &
                              )
                    ELSE
-                      qs1d = kappa * ( q_init(nzb+1) - q_init(nzb) ) / &
-                             LOG( (a-1.0) / (a+1.0) * (b+1.0) / (b-1.0) )
+                      qs1d = kappa * ( q_init(nzb+1) - q_init(nzb) ) /         &
+                             LOG( (a-1.0_wp) / (a+1.0_wp) *                    &
+                                  (b+1.0_wp) / (b-1.0_wp) )
                    ENDIF
                 ENDIF                
                 ELSE
-                   qs1d = 0.0
+                   qs1d = 0.0_wp
                 ENDIF             
 
@@ -629,8 +637,9 @@
              IF ( mixing_length_1d == 'blackadar' )  THEN
                 DO  k = nzb+1, nzt
-                   IF ( rif1d(k) >= 0.0 )  THEN
-                      l1d(k) = l_black(k) / ( 1.0 + 5.0 * rif1d(k) )
+                   IF ( rif1d(k) >= 0.0_wp )  THEN
+                      l1d(k) = l_black(k) / ( 1.0_wp + 5.0_wp * rif1d(k) )
                    ELSE
-                      l1d(k) = l_black(k) * ( 1.0 - 16.0 * rif1d(k) )**0.25
+                      l1d(k) = l_black(k) *                                    &
+                               ( 1.0_wp - 16.0_wp * rif1d(k) )**0.25_wp
                    ENDIF
                    l1d(k) = l_black(k)
@@ -640,7 +649,7 @@
                 DO  k = nzb+1, nzt
                    dpt_dz = ( pt_init(k+1) - pt_init(k-1) ) * dd2zu(k)
-                   IF ( dpt_dz > 0.0 )  THEN
-                      l_stable = 0.76 * SQRT( e1d(k) ) / &
-                                     SQRT( g / pt_init(k) * dpt_dz ) + 1E-5
+                   IF ( dpt_dz > 0.0_wp )  THEN
+                      l_stable = 0.76_wp * SQRT( e1d(k) ) /                    &
+                                     SQRT( g / pt_init(k) * dpt_dz ) + 1E-5_wp
                    ELSE
                       l_stable = l_grid(k)
@@ -657,16 +666,16 @@
 !--          already been taken account of via the TKE (cf. also Diss.).
              IF ( prandtl_layer )  THEN
-                IF ( rif1d(nzb+1) >= 0.0 )  THEN
-                   km1d(nzb+1) = us1d * kappa * zu(nzb+1) / &
-                                 ( 1.0 + 5.0 * rif1d(nzb+1) )
-                ELSE
-                   km1d(nzb+1) = us1d * kappa * zu(nzb+1) * &
-                                 ( 1.0 - 16.0 * rif1d(nzb+1) )**0.25
+                IF ( rif1d(nzb+1) >= 0.0_wp )  THEN
+                   km1d(nzb+1) = us1d * kappa * zu(nzb+1) /                    &
+                                 ( 1.0_wp + 5.0_wp * rif1d(nzb+1) )
+                ELSE
+                   km1d(nzb+1) = us1d * kappa * zu(nzb+1) *                    &
+                                 ( 1.0_wp - 16.0_wp * rif1d(nzb+1) )**0.25_wp
                 ENDIF
              ENDIF
              DO  k = nzb_diff, nzt
 !                km1d(k) = 0.4 * SQRT( e1d(k) ) !changed: adjustment to 3D-model
-                km1d(k) = 0.1 * SQRT( e1d(k) )
-                IF ( rif1d(k) >= 0.0 )  THEN
+                km1d(k) = 0.1_wp * SQRT( e1d(k) )
+                IF ( rif1d(k) >= 0.0_wp )  THEN
                    km1d(k) = km1d(k) * l1d(k)
                 ELSE
@@ -678,5 +687,5 @@
 !--          Add damping layer
              DO  k = damp_level_ind_1d+1, nzt+1
-                km1d(k) = 1.1 * km1d(k-1)
+                km1d(k) = 1.1_wp * km1d(k-1)
                 km1d(k) = MIN( km1d(k), 10.0_wp )
              ENDDO
@@ -686,8 +695,8 @@
 !--          kh = phim / phih * km
              DO  k = nzb+1, nzt
-                IF ( rif1d(k) >= 0.0 )  THEN
+                IF ( rif1d(k) >= 0.0_wp )  THEN
                    kh1d(k) = km1d(k)
                 ELSE
-                   kh1d(k) = km1d(k) * ( 1.0 - 16.0 * rif1d(k) )**0.25
+                   kh1d(k) = km1d(k) * ( 1.0_wp - 16.0_wp * rif1d(k) )**0.25_wp
                 ENDIF
              ENDDO
@@ -778,20 +787,20 @@
 !--    Compute control quantities
 !--    grid level nzp is excluded due to mirror boundary condition
-       umax = 0.0; vmax = 0.0; energy = 0.0
+       umax = 0.0_wp; vmax = 0.0_wp; energy = 0.0_wp
        DO  k = nzb+1, nzt+1
           umax = MAX( ABS( umax ), ABS( u1d(k) ) )
           vmax = MAX( ABS( vmax ), ABS( v1d(k) ) )
-          energy = energy + 0.5 * ( u1d(k)**2 + v1d(k)**2 )
+          energy = energy + 0.5_wp * ( u1d(k)**2 + v1d(k)**2 )
        ENDDO
        energy = energy / REAL( nzt - nzb + 1, KIND=wp )
 
        uv_total = SQRT( u1d(nzb+1)**2 + v1d(nzb+1)**2 )
-       IF ( ABS( v1d(nzb+1) ) .LT. 1.0E-5 )  THEN
+       IF ( ABS( v1d(nzb+1) ) .LT. 1.0E-5_wp )  THEN
           alpha = ACOS( SIGN( 1.0_wp , u1d(nzb+1) ) )
        ELSE
           alpha = ACOS( u1d(nzb+1) / uv_total )
-          IF ( v1d(nzb+1) <= 0.0 )  alpha = 2.0 * pi - alpha
+          IF ( v1d(nzb+1) <= 0.0_wp )  alpha = 2.0_wp * pi - alpha
        ENDIF
-       alpha = alpha / ( 2.0 * pi ) * 360.0
+       alpha = alpha / ( 2.0_wp * pi ) * 360.0_wp
 
        WRITE ( 15, 101 )  current_timestep_number_1d, simulated_time_chr, &
@@ -853,16 +862,16 @@
 !-- Compute the currently feasible time step according to the diffusion
 !-- criterion. At nzb+1 the half grid length is used.
-    fac = 0.35
+    fac = 0.35_wp
     dt_diff = dt_max_1d
     DO  k = nzb+2, nzt
-       value   = fac * dzu(k) * dzu(k) / ( km1d(k) + 1E-20 )
+       value   = fac * dzu(k) * dzu(k) / ( km1d(k) + 1E-20_wp )
        dt_diff = MIN( value, dt_diff )
     ENDDO
-    value   = fac * zu(nzb+1) * zu(nzb+1) / ( km1d(nzb+1) + 1E-20 )
+    value   = fac * zu(nzb+1) * zu(nzb+1) / ( km1d(nzb+1) + 1E-20_wp )
     dt_1d = MIN( value, dt_diff )
 
 !
 !-- Set flag when the time step becomes too small
-    IF ( dt_1d < ( 0.00001 * dt_max_1d ) )  THEN
+    IF ( dt_1d < ( 0.00001_wp * dt_max_1d ) )  THEN
        stop_dt_1d = .TRUE.
 
@@ -876,9 +885,9 @@
 !-- A more or less simple new time step value is obtained taking only the
 !-- first two significant digits
-    div = 1000.0
+    div = 1000.0_wp
     DO  WHILE ( dt_1d < div )
-       div = div / 10.0
+       div = div / 10.0_wp
     ENDDO
-    dt_1d = NINT( dt_1d * 100.0 / div ) * div / 100.0
+    dt_1d = NINT( dt_1d * 100.0_wp / div ) * div / 100.0_wp
 
     old_dt_1d = dt_1d
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 1352)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! REAL constants provided with KIND-attribute 
 ! 
 ! Former revisions:
@@ -616,5 +616,5 @@
                 ENDDO
              ENDDO
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
                   precipitation )  THEN
                 DO  i = nxlg, nxrg
@@ -673,5 +673,5 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              qs = 0.0_wp
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
                   precipitation )  THEN
                 qrs = 0.0_wp
Index: /palm/trunk/SOURCE/init_advec.f90
===================================================================
--- /palm/trunk/SOURCE/init_advec.f90	(revision 1352)
+++ /palm/trunk/SOURCE/init_advec.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants provided with KIND-attribute 
 ! 
 ! Former revisions:
@@ -93,19 +93,19 @@
 
        delt  = 1.0_wp / REAL( intervals, KIND=wp )
-       sterm = delt * 0.5
+       sterm = delt * 0.5_wp
 
        DO  i = 1, intervals
 
-          IF ( sterm > 0.5 )  THEN
-             dn = -5.0
+          IF ( sterm > 0.5_wp )  THEN
+             dn = -5.0_wp
           ELSE
-             dn = 5.0
+             dn = 5.0_wp
           ENDIF
 
           DO  j = 1, 15
-             ex1 = dn * EXP( -dn ) - EXP( 0.5 * dn ) + EXP( -0.5 * dn )
+             ex1 = dn * EXP( -dn ) - EXP( 0.5_wp * dn ) + EXP( -0.5_wp * dn )
              ex2 = EXP( dn ) - EXP( -dn )
-             ex3 = EXP( -dn ) * ( 1.0 - dn ) - 0.5 * EXP(  0.5 * dn ) &
-                                             - 0.5 * EXP( -0.5 * dn )
+             ex3 = EXP( -dn ) * ( 1.0_wp - dn ) - 0.5_wp * EXP(  0.5_wp * dn ) &
+                                                - 0.5_wp * EXP( -0.5_wp * dn )
              ex4 = EXP( dn ) + EXP( -dn )
              ex5 = dn * sterm + ex1 / ex2
@@ -115,12 +115,12 @@
           ENDDO
 
-          IF ( sterm < 0.5 )  dn = MAX(  2.95E-2_wp, dn )
-          IF ( sterm > 0.5 )  dn = MIN( -2.95E-2_wp, dn )
+          IF ( sterm < 0.5_wp )  dn = MAX(  2.95E-2_wp, dn )
+          IF ( sterm > 0.5_wp )  dn = MIN( -2.95E-2_wp, dn )
           ex1 = EXP( -dn )
           ex2 = EXP( dn ) - ex1
           aex(i) = -ex1 / ex2
-          bex(i) = 1.0 / ex2
+          bex(i) = 1.0_wp / ex2
           dex(i) = dn
-          eex(i) = EXP( dex(i) * 0.5 )
+          eex(i) = EXP( dex(i) * 0.5_wp )
           sterm = sterm + delt
 
Index: /palm/trunk/SOURCE/init_cloud_physics.f90
===================================================================
--- /palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1352)
+++ /palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants provided with KIND-attribute
 ! 
 ! Former revisions:
@@ -93,5 +93,5 @@
     REAL(wp) ::  t_surface  !:
 
-    ALLOCATE( hyp(nzb:nzt+1), pt_d_t(nzb:nzt+1), t_d_pt(nzb:nzt+1),  &
+    ALLOCATE( hyp(nzb:nzt+1), pt_d_t(nzb:nzt+1), t_d_pt(nzb:nzt+1),            &
               hyrho(nzb:nzt+1) )
 
@@ -104,16 +104,16 @@
     schmidt_p_1d3 = schmidt**( 1.0_wp / 3.0_wp )
 
-    pirho_l  = pi * rho_l / 6.0
-    dpirho_l = 1.0 / pirho_l 
+    pirho_l  = pi * rho_l / 6.0_wp
+    dpirho_l = 1.0_wp / pirho_l 
 !
 !-- Calculate timestep according to precipitation
     IF ( icloud_scheme == 0  .AND.  precipitation )  THEN
-       dt_precipitation = c_sedimentation * MINVAL( dzu(nzb+2:nzt) ) /        &
+       dt_precipitation = c_sedimentation * MINVAL( dzu(nzb+2:nzt) ) /         &
                           w_precipitation
     ENDIF
 !
 !-- Calculate factor used in equation for droplet growth by condensation
-    bfactor = 3.0 * vanthoff * mass_of_solute * molecular_weight_of_water &
-              / ( 4.0 * pi * rho_l * molecular_weight_of_solute )
+    bfactor = 3.0_wp * vanthoff * mass_of_solute * molecular_weight_of_water   &
+              / ( 4.0_wp * pi * rho_l * molecular_weight_of_solute )
 !
 !-- Calculate:
@@ -121,17 +121,17 @@
 !-- t / pt : ratio of actual and potential temperature (t_d_pt)
 !-- p_0(z) : vertical profile of the hydrostatic pressure (hyp)
-    t_surface = pt_surface * ( surface_pressure / 1000.0 )**0.286_wp
+    t_surface = pt_surface * ( surface_pressure / 1000.0_wp )**0.286_wp
     DO  k = nzb, nzt+1
 !
 !--    Check temperature in case of too large domain height
-       IF ( ( t_surface - g/cp * zu(k) ) < 0.0 )  THEN
+       IF ( ( t_surface - g/cp * zu(k) ) < 0.0_wp )  THEN
           WRITE( message_string, * )  'absolute temperature < 0.0 at zu(', k, &
                                       ') = ', zu(k)
           CALL message( 'init_cloud_physics', 'PA0142', 1, 2, 0, 6, 0 )
        ENDIF
-       hyp(k)    = surface_pressure * 100.0 * &
+       hyp(k)    = surface_pressure * 100.0_wp * &
                    ( (t_surface - g/cp * zu(k)) / t_surface )**(1.0_wp/0.286_wp)
-       pt_d_t(k) = ( 100000.0 / hyp(k) )**0.286_wp
-       t_d_pt(k) = 1.0 / pt_d_t(k)
+       pt_d_t(k) = ( 100000.0_wp / hyp(k) )**0.286_wp
+       t_d_pt(k) = 1.0_wp / pt_d_t(k)
        hyrho(k)  = hyp(k) / ( r_d * t_d_pt(k) * pt_init(k) )       
     ENDDO
@@ -139,5 +139,5 @@
 !
 !-- Compute reference density
-    rho_surface = surface_pressure * 100.0 / ( r_d * t_surface )
+    rho_surface = surface_pressure * 100.0_wp / ( r_d * t_surface )
 
 
